'**********************************************************************
'Project : Demo program on how to set and read Micro128's Real Time Clock
'Company : Micromint, Inc.
'
'**********************************************************************

$regfile = "m128def.dat"
$baud1 = 9600


'Configure the serial port.
Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
'Configure PORTD.6 as an ouput and the rest of the port as inputs.
Ddrd = 64
On Int5 Int5_int                                            'Initialise the INT5 Interrupt

Enable Interrupts
                                                 'enable the interrupt
Disable Int5
'Open the serial port
Open "com2:" For Random As #1
Dim Result As Word At &HFFE
Dim Dat As Byte At &HFFD
Dim Tenthsec As Byte
Dim Second As Byte
Dim Minute As Byte
Dim Hour As Byte
Dim Dow As Byte
Dim Dom As Byte
Dim Month As Byte
Dim Year As Byte
Dim B As Byte

Portd.6 = 1                                                 'Enable the transmitter
Waitms 10                                                   'Wait for the transmitter to settle.
Do
   Print #1 , "RTC Menu"
   Print #1 , "1 - Set the Time"
   Print #1 , "2 - Read the Time"
   Print #1 , "3 - Set the Alarm"
   Print #1 , "4 - Read the Alarm"
   Print #1 , "5 - Enable the Alarm"
   Input #1 , B
   Select Case B
    Case 1 : Gosub Setclk
    Case 2 : Gosub Readclock
    Case 3 : Gosub Setalarm
    Case 4 : Gosub Readalarm
    Case 5 : Gosub Enablealarm
  End Select

Loop





Setclk:
   Print #1 , "Please enter the Seconds."
   Input #1 , Second
   Second = Makebcd(second)
   Print #1 , "Please enter the Minutes."
   Input #1 , Minute
   Minute = Makebcd(minute)
   Print #1 , "Please enter the Hours."
   Input #1 , Hour
   Hour = Makebcd(hour)
   Print #1 , "Please enter the Day of the Week. 1 = Sunday."
   Input #1 , Dow
   Dow = Makebcd(dow)
   Print #1 , "Please enter the Month."
   Input #1 , Month
   Month = Makebcd(month)
   Print #1 , "Please enter the Day of the Month."
   Input #1 , Dom
   Dom = Makebcd(dom)
   Print #1 , "Please enter the Year."
   Input #1 , Year
   Year = Makebcd(year)
   Dat = Second
   $asm
     !Call $FD1A
   $end Asm
   Dat = Minute
   $asm
     !Call $FD22
   $end Asm
   Dat = Hour
   $asm
     !Call $FD26
   $end Asm
   Dat = Dow
   $asm
     !Call $FD2E
   $end Asm
   Dat = Month
   $asm
     !Call $FD36
   $end Asm
   Dat = Dom
   $asm
     !Call $FD32
   $end Asm
   Dat = Year
   $asm
     !Call $FD3A
   $end Asm
Return

Readclock:
Do
   $asm
     !Call $FCF8
   $end Asm
   Tenthsec = Result
   $asm
     !Call $FCFC
   $end Asm
   Second = Result
   $asm
     !Call $FD01
   $end Asm
   Minute = Result
   $asm
     !Call $FD05
   $end Asm
   Hour = Result
   $asm
     !Call $FD0A
   $end Asm
   Dow = Result
   $asm
     !Call $FD0E
   $end Asm
   Dom = Result
   $asm
     !Call $FD12
   $end Asm
   Month = Result
   $asm
     !Call $FD16
   $end Asm
   Year = Result
   Select Case Dow
    Case 1 : Print #1 , "Sunday ";
    Case 2 : Print #1 , "Monday ";
    Case 3 : Print #1 , "Tuesday ";
    Case 4 : Print #1 , "Wednesday ";
    Case 5 : Print #1 , "Thursday ";
    Case 6 : Print #1 , "Friday ";
    Case 7 : Print #1 , "Saturday ";
  End Select
   Print #1 , Bcd(month) ; "/" ; Bcd(dom) ; "/" ; Bcd(year) ; " " ; Bcd(hour) ; ":" ; Bcd(minute) ; ":" ; Bcd(second) ; ":" ; Bcd(tenthsec) ; Chr(13);
   B = Inkey(#1)
Loop Until B <> 64

Return

Setalarm:
Print #1 , "Please enter the Alarm Seconds."
   Input #1 , Second
   Second = Makebcd(second)
   Print #1 , "Please enter the Alarm Minutes."
   Input #1 , Minute
   Minute = Makebcd(minute)
   Print #1 , "Please enter the Alarm Hours."
   Input #1 , Hour
   Hour = Makebcd(hour)
   Print #1 , "Please enter the Alarm Month."
   Input #1 , Month
   Month = Makebcd(month)
   Print #1 , "Please enter the Alarm Day of the Month."
   Input #1 , Dom
   Dom = Makebcd(dom)
   Month.7 = 1

   Dat = Dom
   $asm
     !Call $FD96
   $end Asm
   Dat = Month
   $asm
     !Call $FDA9
   $end Asm
   Dat = Hour
   $asm
     !Call $FD83
   $end Asm
   Dat = Minute
   $asm
     !Call $FD70
   $end Asm
   Dat = Second
   $asm
     !Call $FD5D
   $end Asm

Return
Readalarm:
   $asm
     !Call $FD3E
   $end Asm
   Second = Result
   $asm
     !Call $FD43
   $end Asm
   Minute = Result
   $asm
     !Call $FD48
   $end Asm
   Hour = Result
   $asm
     !Call $FD52
   $end Asm
   Month = Result
   $asm
     !Call $FD4D
   $end Asm
   Dom = Result
   Print #1 , Bcd(month) ; "/" ; Bcd(dom) ; " " ; Bcd(hour) ; ":" ; Bcd(minute) ; ":" ; Bcd(second)
Return

Enablealarm:
   Print #1 , "Enable RTC Alarm Menu"
   Print #1 , "1 - Every Second"
   Print #1 , "2 - Every Minute"
   Print #1 , "3 - Every Hour"
   Print #1 , "4 - Every Day"
   Print #1 , "5 - Every Month"
   Print #1 , "6 - Every Year"
   Print #1 , "7 - Disable the Alarm"
   Input #1 , B
   Select Case B
    Case 1 :
            $asm
             !Call $FDD7
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 2 :
            $asm
             !Call $FE00
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 3 :
            $asm
             !Call $FE29
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 4 :
            $asm
             !Call $FE52
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 5 :
            $asm
             !Call $FE7B
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 6 :
            $asm
             !Call $FEA7
            $end Asm
            $asm
             !Call $FDBE
            $end Asm
    Case 7 :
            $asm
             !Call $FDCC
            $end Asm
  End Select
  Enable Int5
Return
Int5_int:
      Disable Int5
      PUSH R31
      PUSH R30
      PUSH R29
      PUSH R28
      PUSH R27
      PUSH R26
      PUSH R25
      PUSH R24
      PUSH R23
      PUSH R22
      PUSH R21
      PUSH R20
      PUSH R19
      PUSH R18
      PUSH R17
      PUSH R16
      PUSH R15
      PUSH R14
      PUSH R13
      PUSH R12
      PUSH R11
      PUSH R10
      PUSH R9
      PUSH R8
      PUSH R7
      PUSH R6
      PUSH R5
      PUSH R4
      PUSH R3
      PUSH R2
      PUSH R1
      PUSH R0
      Portd.6 = 1                                                 'Enable the transmitter
      Waitms 10
      Print #1 , "Alarm Alarm"
      $asm
         !Call $FED0
      $end Asm
      POP R0
      POP R1
      POP R2
      POP R3
      POP R4
      POP R5
      POP R6
      POP R7
      POP R8
      POP R9
      POP R10
      POP R11
      POP R12
      POP R13
      POP R14
      POP R15
      POP R16
      POP R17
      POP R18
      POP R19
      POP R20
      POP R21
      POP R22
      POP R23
      POP R24
      POP R25
      POP R26
      POP R27
      POP R28
      POP R29
      POP R30
      POP R31
      Enable Int5
Return
Close #1

End